# CPU: Intel(R) Xeon(R) CPU X5675 @ 3.07GHz
# RAM: 32GB
# Configuration: -c consts -s -a
# With Boolector 1.6.0 (-minisat): 463m36.245s + 0m23.258s (re-verify sat cases with the configuration -c consts -s)

int64 rp
int64 xp

input rp
input xp

int64 r0
int64 r1
int64 r2
int64 r3
int64 r4

int64 c1
int64 c2
int64 c3
int64 c4
int64 c5
int64 c6
int64 c7
caller c1
caller c2
caller c3
caller c4
caller c5
caller c6
caller c7
stack64 c1_stack
stack64 c2_stack
stack64 c3_stack
stack64 c4_stack
stack64 c5_stack
stack64 c6_stack
stack64 c7_stack
stack64 x119_stack
stack64 x219_stack
stack64 x319_stack
stack64 x419_stack

#required for  macro
int64 r01
int64 r11
int64 r21
int64 r31
int64 r41
int64 rax
int64 rdx
int64 t
int64 redmask

enter fe25519_sq

c1_stack = c1
c2_stack = c2
c3_stack = c3
c4_stack = c4
c5_stack = c5
c6_stack = c6
c7_stack = c7

###################################################################
# Conditions on the inputs: x0 = *(uint64 *)(xp +  0),
#                           x1 = *(uint64 *)(xp +  8),
#                           x2 = *(uint64 *)(xp + 16),
#                           x3 = *(uint64 *)(xp + 24),
#                           x4 = *(uint64 *)(xp + 32), are all in [0,2^54-1]
#
###################################################################

  #// inv 0 <=u xp[0], xp[8], xp[16], xp[24], xp[32] <u 2**54

  #BEGIN MACRO 
  rax = *(uint64 *)(xp + 0)
  (uint128) rdx rax = rax * *(uint64 *)(xp + 0)
  r0 = rax
  r01 = rdx

  #// var r0_0 = r01.r0
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r01.r0 = r0_0

  rax = *(uint64 *)(xp + 0)
  rax <<= 1
  (uint128) rdx rax = rax * *(uint64 *)(xp + 8)
  r1 = rax
  r11 = rdx

  #// var r1_0 = r11.r1
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0

  rax = *(uint64 *)(xp + 0)
  rax <<= 1
  (uint128) rdx rax = rax * *(uint64 *)(xp + 16)
  r2 = rax
  r21 = rdx

  #// var r2_0 = r21.r2
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_0

  rax = *(uint64 *)(xp + 0)
  rax <<= 1
  (uint128) rdx rax = rax * *(uint64 *)(xp + 24)
  r3 = rax
  r31 = rdx

  #// var r3_0 = r31.r3
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_0 &&
  #//     r31.r3 = r3_0

  rax = *(uint64 *)(xp + 0)
  rax <<= 1
  (uint128) rdx rax = rax * *(uint64 *)(xp + 32)
  r4 = rax
  r41 = rdx

  #// var r4_0 = r41.r4
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_0 &&
  #//     r31.r3 = r3_0 &&
  #//     r41.r4 = r4_0

  rax = *(uint64 *)(xp + 8)
  (uint128) rdx rax = rax * *(uint64 *)(xp + 8)
  carry? r2 += rax
  r21 += rdx + carry

  #// var r2_1 = r21.r2
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_0 &&
  #//     r41.r4 = r4_0

  rax = *(uint64 *)(xp + 8)
  rax <<= 1
  (uint128) rdx rax = rax * *(uint64 *)(xp + 16)
  carry? r3 += rax
  r31 += rdx + carry

  #// var r3_1 = r31.r3
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_0

  rax = *(uint64 *)(xp + 8)
  rax <<= 1
  (uint128) rdx rax = rax * *(uint64 *)(xp + 24)
  carry? r4 += rax
  r41 += rdx + carry

  #// var r4_1 = r41.r4
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r01.r0 = r0_0 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_1

  rax = *(uint64 *)(xp + 8)
  rax *= 38
  (uint128) rdx rax = rax * *(uint64 *)(xp + 32)
  carry? r0 += rax
  r01 += rdx + carry

  #// var r0_1 = r01.r0
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r01.r0 = r0_1 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_1
  
  rax = *(uint64 *)(xp + 16)
  (uint128) rdx rax = rax * *(uint64 *)(xp + 16)
  carry? r4 += rax
  r41 += rdx + carry

  #// var r4_2 = r41.r4
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r4_2 = r4_1 + xp[16]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_1 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_2

  rax = *(uint64 *)(xp + 16)
  rax *= 38
  (uint128) rdx rax = rax * *(uint64 *)(xp + 24)
  carry? r0 += rax
  r01 += rdx + carry

  #// var r0_2 = r01.r0
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r0_2 = r0_1 + 38 * xp[16]@u128 * xp[24]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r4_2 = r4_1 + xp[16]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_2 &&
  #//     r11.r1 = r1_0 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_2

  rax = *(uint64 *)(xp + 16)
  rax *= 38
  (uint128) rdx rax = rax * *(uint64 *)(xp + 32)
  carry? r1 += rax
  r11 += rdx + carry

  #// var r1_1 = r11.r1
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r0_2 = r0_1 + 38 * xp[16]@u128 * xp[24]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r1_1 = r1_0 + 38 * xp[16]@u128 * xp[32]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r4_2 = r4_1 + xp[16]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_2 &&
  #//     r11.r1 = r1_1 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_2

  rax = *(uint64 *)(xp + 24)
  rax *= 19
  (uint128) rdx rax = rax * *(uint64 *)(xp + 24)
  carry? r1 += rax
  r11 += rdx + carry

  #// var r1_2 = r11.r1
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r0_2 = r0_1 + 38 * xp[16]@u128 * xp[24]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r1_1 = r1_0 + 38 * xp[16]@u128 * xp[32]@u128 &&
  #//     r1_2 = r1_1 + 19 * xp[24]@u128 * xp[24]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r4_2 = r4_1 + xp[16]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_2 &&
  #//     r11.r1 = r1_2 &&
  #//     r21.r2 = r2_1 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_2

  rax = *(uint64 *)(xp + 24)
  rax *= 38
  (uint128) rdx rax = rax * *(uint64 *)(xp + 32)
  carry? r2 += rax
  r21 += rdx + carry

  #// var r2_2 = r21.r2
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r0_2 = r0_1 + 38 * xp[16]@u128 * xp[24]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r1_1 = r1_0 + 38 * xp[16]@u128 * xp[32]@u128 &&
  #//     r1_2 = r1_1 + 19 * xp[24]@u128 * xp[24]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r2_2 = r2_1 + 38 * xp[24]@u128 * xp[32]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r4_2 = r4_1 + xp[16]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_2 &&
  #//     r11.r1 = r1_2 &&
  #//     r21.r2 = r2_2 &&
  #//     r31.r3 = r3_1 &&
  #//     r41.r4 = r4_2
  
  rax = *(uint64 *)(xp + 32)
  rax *= 19
  (uint128) rdx rax = rax * *(uint64 *)(xp + 32)
  carry? r3 += rax
  r31 += rdx + carry

  #// var r3_2 = r31.r3
  #// cut r0_0 = xp[0]@u128 * xp[0]@u128 &&
  #//     r0_1 = r0_0 + 38 * xp[8]@u128 * xp[32]@u128 &&
  #//     r0_2 = r0_1 + 38 * xp[16]@u128 * xp[24]@u128 &&
  #//     r1_0 = 2 * xp[0]@u128 * xp[8]@u128 &&
  #//     r1_1 = r1_0 + 38 * xp[16]@u128 * xp[32]@u128 &&
  #//     r1_2 = r1_1 + 19 * xp[24]@u128 * xp[24]@u128 &&
  #//     r2_0 = 2 * xp[0]@u128 * xp[16]@u128 &&
  #//     r2_1 = r2_0 + xp[8]@u128 * xp[8]@u128 &&
  #//     r2_2 = r2_1 + 38 * xp[24]@u128 * xp[32]@u128 &&
  #//     r3_0 = 2 * xp[0]@u128 * xp[24]@u128 &&
  #//     r3_1 = r3_0 + 2 * xp[8]@u128 * xp[16]@u128 &&
  #//     r3_2 = r3_1 + 19 * xp[32]@u128 * xp[32]@u128 &&
  #//     r4_0 = 2 * xp[0]@u128 * xp[32]@u128 &&
  #//     r4_1 = r4_0 + 2 * xp[8]@u128 * xp[24]@u128 &&
  #//     r4_2 = r4_1 + xp[16]@u128 * xp[16]@u128 &&
  #//     r01.r0 = r0_2 &&
  #//     r11.r1 = r1_2 &&
  #//     r21.r2 = r2_2 &&
  #//     r31.r3 = r3_2 &&
  #//     r41.r4 = r4_2

  # Note: The following assertion has to be verified without -a.
  #// assert r01.r0 = xp[0]@u128 * xp[0]@u128 + 38 * xp[8]@u128 * xp[32]@u128 + 38 * xp[16]@u128 * xp[24]@u128 &&
  #//        r11.r1 = 2 * xp[0]@u128 * xp[8]@u128 + 38 * xp[16]@u128 * xp[32]@u128 + 19 * xp[24]@u128 * xp[24]@u128 &&
  #//        r21.r2 = 2 * xp[0]@u128 * xp[16]@u128 + xp[8]@u128 * xp[8]@u128 + 38 * xp[24]@u128 * xp[32]@u128 &&
  #//        r31.r3 = 2 * xp[0]@u128 * xp[24]@u128 + 2 * xp[8]@u128 * xp[16]@u128 + 19 * xp[32]@u128 * xp[32]@u128 &&
  #//        r41.r4 = 2 * xp[0]@u128 * xp[32]@u128 + 2 * xp[8]@u128 * xp[24]@u128 + xp[16]@u128 * xp[16]@u128

  # Note: The following assertion has to be verified without -a.
  #// cut 0 <=u r01.r0 <u 2**54 * 2**54 + 19 * 2**54 * 2**54 * 4 &&
  #//     0 <=u r11.r1 <u 2**54 * 2**54 * 2 + 19 * 2**54 * 2**54 * 3 &&
  #//     0 <=u r21.r2 <u 2**54 * 2**54 * 3 + 19 * 2**54 * 2**54 * 2 &&
  #//     0 <=u r31.r3 <u 2**54 * 2**54 * 4 + 19 * 2**54 * 2**54 * 1 &&
  #//     0 <=u r41.r4 <u 2**54 * 2**54 * 5

###################################################################
# The following should hold at this point:
#
# (x0 + 2^51*x1 + 2^102*x2 + 2^153*x3 + 2^204*x4) * (x0 + 2^51*x1 + 2^102*x2 + 2^153*x3 + 2^204*x4) congruent to (r0h.r0l) + (r1h.r1l)*2^51 + (r2h.r2l)*2^102 + (r3h.r3l)*2^153 + (r4h.r4l)*2^204  [modulo 2^255-19]
# 
# Notation: (X.Y) stands for a 128-bit value with the least significant 64 bits in Y and the 64 most significant bits in X
#
###################################################################

  #// var r0_512 = (r01@u128.r0@u128)@u512
  #//     r1_512 = (r11@u128.r1@u128)@u512
  #//     r2_512 = (r21@u128.r2@u128)@u512
  #//     r3_512 = (r31@u128.r3@u128)@u512
  #//     r4_512 = (r41@u128.r4@u128)@u512

  redmask = *(uint64 *) &crypto_sign_ed25519_amd64_51_REDMASK51
  
  r01 = (r01.r0) << 13
  r0 &= redmask
  
  r11 = (r11.r1) << 13
  r1 &= redmask
  r1 += r01
  
  r21 = (r21.r2) << 13
  r2 &= redmask
  r2 += r11
  
  r31 = (r31.r3) << 13
  r3 &= redmask
  r3 += r21
  
  r41 = (r41.r4) << 13
  r4 &= redmask
  r4 += r31
  r41 = r41 * 19
  r0 += r41

  #// var lhs = r0_512 + r1_512 * 2**51 + r2_512 * 2**102 + r3_512 * 2**153 + r4_512 * 2**204
  #//     rhs = r0@u512 + r1@u512 * 2**51 + r2@u512 * 2**102 + r3@u512 * 2**153 + r4@u512 * 2**204
  #// assert lhs >=u rhs && (lhs - rhs) % (2**255 - 19) = 0
  #// cut 0 <=u r0 <u 2**64 - 2**63 + 2**62 &&
  #//     0 <=u r1 <u 2**64 - 2**63 + 2**61 &&
  #//     0 <=u r2 <u 2**63 - 2**60 + 2**59 &&
  #//     0 <=u r3 <u 2**62 + 2**61 - 2**59 &&
  #//     0 <=u r4 <u 2**61 + 2**60 - 2**56 &&
  #//     redmask = mem64[crypto_sign_ed25519_amd64_51_REDMASK51]

  #// var r0_512 = r0@u512
  #//     r1_512 = r1@u512
  #//     r2_512 = r2@u512
  #//     r3_512 = r3@u512
  #//     r4_512 = r4@u512

  t = r0
  (uint64) t >>= 51
  t += r1
  r0 &= redmask
  
  r1 = t
  (uint64) t >>= 51
  t += r2
  r1 &= redmask
  
  r2 = t
  (uint64) t >>= 51
  t += r3
  r2 &= redmask
  
  r3 = t
  (uint64) t >>= 51
  t += r4
  r3 &= redmask
  
  r4 = t
  (uint64) t >>= 51
  t *= 19
  r0 += t
  r4 &= redmask
  #END MACRO 

  #// var lhs = r0_512 + r1_512 * 2**51 + r2_512 * 2**102 + r3_512 * 2**153 + r4_512 * 2**204
  #//     rhs = r0@u512 + r1@u512 * 2**51 + r2@u512 * 2**102 + r3@u512 * 2**153 + r4@u512 * 2**204
  #// assert lhs >=u rhs && (lhs - rhs) % (2**255 - 19) = 0 &&
  #//        0 <=u r0 <=u 2**51 + 2**15 &&
  #//        0 <=u r1 <=u 2**51 + 2**15 &&
  #//        0 <=u r2 <=u 2**51 + 2**15 &&
  #//        0 <=u r3 <=u 2**51 + 2**15 &&
  #//        0 <=u r4 <=u 2**51 + 2**15

*(uint64 *)(rp + 0) = r0
*(uint64 *)(rp + 8) = r1
*(uint64 *)(rp + 16) = r2
*(uint64 *)(rp + 24) = r3
*(uint64 *)(rp + 32) = r4
 
###################################################################
# The following should hold at this point:
#
# (x0 + 2^51*x1 + 2^102*x2 + 2^153*x3 + 2^204*x4) * (x0 + 2^51*x1 + 2^102*x2 + 2^153*x3 + 2^204*x4) congruent to (r0l + r1l*2^51 + r2l*2^102 + r3l*2^153 + r4l*2^204)  [modulo 2^255-19]
#
# r0l,r1l,r2l,r3l,r4l are all in [0,2^51+2^15]
#
###################################################################
  

c1 =c1_stack
c2 =c2_stack
c3 =c3_stack
c4 =c4_stack
c5 =c5_stack
c6 =c6_stack
c7 =c7_stack

leave
